"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.initialize = void 0;
const tslib_1 = require("tslib");
const rangetouch_1 = tslib_1.__importDefault(require("rangetouch"));
const instances = new WeakMap();
function registerOne(target) {
    if (!instances.has(target)) {
        instances.set(target, new rangetouch_1.default(target, { watch: false, addCSS: false, thumbWidth: 8 }));
    }
}
function registerRecursive(target) {
    const selector = 'input[type=range]';
    if (target.matches && target.matches(selector)) {
        registerOne(target);
    }
    target.querySelectorAll && target.querySelectorAll(selector).forEach(registerOne);
}
let observer = null;
function initialize() {
    if (observer) {
        return;
    }
    registerRecursive(document.body);
    observer = new MutationObserver(mutations => mutations.forEach(mutation => mutation.addedNodes.forEach(registerRecursive)));
    observer.observe(document.body, {
        attributes: false,
        characterData: false,
        childList: true,
        subtree: true
    });
}
exports.initialize = initialize;
//# sourceMappingURL=rangetouch.js.map