"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const inversify_1 = require("inversify");
let MediaApi = class MediaApi {
    constructor() {
        this._watchMedia = (queryList) => {
            this._queries.forEach(q => {
                if (q.removeEventListener) {
                    q.removeEventListener('change', this._updateQueries);
                }
                else {
                    q.removeListener(this._updateQueries);
                }
            });
            this._queries = queryList.map(q => matchMedia(q));
            this._queries.forEach(q => {
                if (q.removeEventListener) {
                    q.addEventListener('change', this._updateQueries);
                }
                else {
                    q.addListener(this._updateQueries);
                }
            });
            this._updateQueries();
        };
        this._updateQueries = () => this._ports.onMediaUpdate_.send(this._queries.map(q => q.matches));
        this._queries = [];
    }
    init(ports) {
        this._ports = ports;
        ports.watchMedia_.subscribe(this._watchMedia);
    }
};
MediaApi = tslib_1.__decorate([
    inversify_1.injectable()
], MediaApi);
exports.default = MediaApi;
//# sourceMappingURL=MediaApi.js.map