import { Cartridge, Settings } from '../../elm/Stellerator/Main.elm';
export interface CartridgeWithImage {
    cartridge: Cartridge;
    image: Uint8Array;
}
declare class Storage {
    setDefaults(settings: Settings): void;
    getAllCartridges(): Promise<Array<Cartridge>>;
    insertCartridges(cartridges: Array<CartridgeWithImage>): Promise<void>;
    updateCartridge(cartridge: Cartridge): Promise<void>;
    deleteCartridge(hash: string): Promise<void>;
    deleteAllCartridges(): Promise<void>;
    getCartridge(hash: string): Promise<Cartridge | undefined>;
    getCartridgeImage(hash: string): Promise<Uint8Array | undefined>;
    getSettings(): Promise<Settings | undefined>;
    saveSettings(settings: Settings): Promise<void>;
    dropDatabase(): Promise<void>;
    private _database;
    private _defaultSettings;
}
export default Storage;
