"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = void 0;
const tslib_1 = require("tslib");
const pathlib = tslib_1.__importStar(require("path"));
class AbstractFileSystemProvider {
    constructor() {
        this._directoryStack = [];
        this._cwd = '/';
    }
    pushd(path) {
        this._directoryStack.unshift(this._cwd);
        if (typeof path !== 'undefined') {
            this.chdir(path);
        }
    }
    popd() {
        if (this._directoryStack.length === 0) {
            return undefined;
        }
        const targetDir = this._directoryStack.shift();
        this.chdir(targetDir);
        return targetDir;
    }
    cwd() {
        return this._cwd;
    }
    chdir(path) {
        this._cwd = this._resolvePath(path);
    }
    _resolvePath(path) {
        return pathlib.resolve(this._cwd, path);
    }
}
exports.default = AbstractFileSystemProvider;
//# sourceMappingURL=AbstractFileSystemProvider.js.map