interface FileSystemProviderInterface {
    readBinaryFileSync(name: string): FileSystemProviderInterface.FileBufferInterface;
    readTextFileSync(name: string): string;
    readDirSync(name: string): Array<string>;
    getTypeSync(name: string): FileSystemProviderInterface.FileType;
    chdir(path: string): void;
    pushd(path?: string): void;
    popd(): string;
    cwd(): string;
}
declare namespace FileSystemProviderInterface {
    interface FileBufferInterface {
        [index: number]: number;
        length: number;
    }
    const enum FileType {
        DIRECTORY = 0,
        FILE = 1
    }
}
export { FileSystemProviderInterface as default };
