"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = void 0;
const tslib_1 = require("tslib");
const fs = tslib_1.__importStar(require("fs"));
const AbstractFileSystemProvider_1 = tslib_1.__importDefault(require("./AbstractFileSystemProvider"));
class NodeFilesystemProvider extends AbstractFileSystemProvider_1.default {
    constructor() {
        super();
        this._cwd = process.cwd();
    }
    readBinaryFileSync(name) {
        return fs.readFileSync(this._resolvePath(name));
    }
    readTextFileSync(name) {
        return this.readBinaryFileSync(name).toString('utf8');
    }
    readDirSync(name) {
        return fs.readdirSync(this._resolvePath(name));
    }
    getTypeSync(name) {
        if (fs.statSync(this._resolvePath(name)).isDirectory()) {
            return 0;
        }
        else {
            return 1;
        }
    }
}
exports.default = NodeFilesystemProvider;
//# sourceMappingURL=NodeFilesystemProvider.js.map