interface CpuInterface {
    setInterrupt(irq: boolean): CpuInterface;
    isInterrupt(): boolean;
    nmi(): CpuInterface;
    halt(): CpuInterface;
    resume(): CpuInterface;
    isHalt(): boolean;
    setInvalidInstructionCallback(callback: CpuInterface.InvalidInstructionCallbackInterface): CpuInterface;
    getInvalidInstructionCallback(): CpuInterface.InvalidInstructionCallbackInterface;
    getLastInstructionPointer(): number;
    reset(): CpuInterface;
    cycle(): CpuInterface;
    executionState: CpuInterface.ExecutionState;
    state: CpuInterface.State;
}
declare namespace CpuInterface {
    const enum ExecutionState {
        boot = 0,
        fetch = 1,
        execute = 2
    }
    class State {
        a: number;
        x: number;
        y: number;
        s: number;
        p: number;
        flags: number;
        irq: boolean;
        nmi: boolean;
    }
    const enum Flags {
        c = 1,
        z = 2,
        i = 4,
        d = 8,
        b = 16,
        e = 32,
        v = 64,
        n = 128
    }
    interface InvalidInstructionCallbackInterface {
        (cpu?: CpuInterface): void;
    }
}
export { CpuInterface as default };
