"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const StateMachineCpu_1 = tslib_1.__importDefault(require("./StateMachineCpu"));
const BatchedAccessCpu_1 = tslib_1.__importDefault(require("./BatchedAccessCpu"));
class Factory {
    constructor(_type) {
        this._type = _type;
    }
    create(bus, rng) {
        switch (this._type) {
            case Factory.Type.stateMachine:
                return new StateMachineCpu_1.default(bus, rng);
            case Factory.Type.batchedAccess:
                return new BatchedAccessCpu_1.default(bus, rng);
            default:
                throw new Error('invalid CPU type');
        }
    }
}
(function (Factory) {
    let Type;
    (function (Type) {
        Type[Type["stateMachine"] = 0] = "stateMachine";
        Type[Type["batchedAccess"] = 1] = "batchedAccess";
    })(Type = Factory.Type || (Factory.Type = {}));
})(Factory || (Factory = {}));
exports.default = Factory;
//# sourceMappingURL=Factory.js.map