declare class Instruction {
    readonly operation: Instruction.Operation;
    readonly addressingMode: Instruction.AddressingMode;
    readonly effectiveAddressingMode: Instruction.AddressingMode;
    constructor(operation: Instruction.Operation, addressingMode: Instruction.AddressingMode, effectiveAddressingMode?: Instruction.AddressingMode);
    getSize(): number;
}
declare namespace Instruction {
    const enum Operation {
        adc = 0,
        and = 1,
        asl = 2,
        bcc = 3,
        bcs = 4,
        beq = 5,
        bit = 6,
        bmi = 7,
        bne = 8,
        bpl = 9,
        brk = 10,
        bvc = 11,
        bvs = 12,
        clc = 13,
        cld = 14,
        cli = 15,
        clv = 16,
        cmp = 17,
        cpx = 18,
        cpy = 19,
        dec = 20,
        dex = 21,
        dey = 22,
        eor = 23,
        inc = 24,
        inx = 25,
        iny = 26,
        jmp = 27,
        jsr = 28,
        lda = 29,
        ldx = 30,
        ldy = 31,
        lsr = 32,
        nop = 33,
        ora = 34,
        pha = 35,
        php = 36,
        pla = 37,
        plp = 38,
        rol = 39,
        ror = 40,
        rti = 41,
        rts = 42,
        sbc = 43,
        sec = 44,
        sed = 45,
        sei = 46,
        sta = 47,
        stx = 48,
        sty = 49,
        tax = 50,
        tay = 51,
        tsx = 52,
        txa = 53,
        txs = 54,
        tya = 55,
        dop = 56,
        top = 57,
        alr = 58,
        axs = 59,
        dcp = 60,
        lax = 61,
        arr = 62,
        slo = 63,
        aax = 64,
        lar = 65,
        isc = 66,
        aac = 67,
        atx = 68,
        rra = 69,
        rla = 70,
        invalid = 71
    }
    enum OperationMap {
        adc = 0,
        and = 1,
        asl = 2,
        bcc = 3,
        bcs = 4,
        beq = 5,
        bit = 6,
        bmi = 7,
        bne = 8,
        bpl = 9,
        brk = 10,
        bvc = 11,
        bvs = 12,
        clc = 13,
        cld = 14,
        cli = 15,
        clv = 16,
        cmp = 17,
        cpx = 18,
        cpy = 19,
        dec = 20,
        dex = 21,
        dey = 22,
        eor = 23,
        inc = 24,
        inx = 25,
        iny = 26,
        jmp = 27,
        jsr = 28,
        lda = 29,
        ldx = 30,
        ldy = 31,
        lsr = 32,
        nop = 33,
        ora = 34,
        pha = 35,
        php = 36,
        pla = 37,
        plp = 38,
        rol = 39,
        ror = 40,
        rti = 41,
        rts = 42,
        sbc = 43,
        sec = 44,
        sed = 45,
        sei = 46,
        sta = 47,
        stx = 48,
        sty = 49,
        tax = 50,
        tay = 51,
        tsx = 52,
        txa = 53,
        txs = 54,
        tya = 55,
        dop = 56,
        top = 57,
        alr = 58,
        axs = 59,
        dcp = 60,
        lax = 61,
        arr = 62,
        slo = 63,
        aax = 64,
        lar = 65,
        isc = 66,
        aac = 67,
        atx = 68,
        rra = 69,
        rla = 70,
        invalid = 71
    }
    const enum AddressingMode {
        implied = 0,
        immediate = 1,
        zeroPage = 2,
        absolute = 3,
        indirect = 4,
        relative = 5,
        zeroPageX = 6,
        absoluteX = 7,
        indexedIndirectX = 8,
        zeroPageY = 9,
        absoluteY = 10,
        indirectIndexedY = 11,
        invalid = 12
    }
    const opcodes: Instruction[];
}
export { Instruction as default };
declare namespace Instruction {
    namespace __init {
    }
}
