import CpuInterface from './CpuInterface';
import BusInterface from '../bus/BusInterface';
import RngInterface from '../../tools/rng/GeneratorInterface';
declare class StateMachineCpu implements CpuInterface {
    private _bus;
    private _rng?;
    constructor(_bus: BusInterface, _rng?: RngInterface);
    reset(): this;
    setInterrupt(i: boolean): this;
    isInterrupt(): boolean;
    nmi(): this;
    halt(): this;
    resume(): this;
    isHalt(): boolean;
    setInvalidInstructionCallback(callback: CpuInterface.InvalidInstructionCallbackInterface): this;
    getInvalidInstructionCallback(): CpuInterface.InvalidInstructionCallbackInterface;
    getLastInstructionPointer(): number;
    cycle(): this;
    private _fetch;
    private _pollInterrupts;
    executionState: CpuInterface.ExecutionState;
    state: CpuInterface.State;
    private _invalidInstructionCallback;
    private _lastResult;
    private _interruptPending;
    private _nmiPending;
    private _halt;
    private _pollInterruptsAfterLastInstruction;
    private _lastInstructionPointer;
    private _opBoot;
    private _opNmi;
    private _opIrq;
    private _operations;
}
export default StateMachineCpu;
