import CpuInterface from './CpuInterface';
import BusInterface from '../bus/BusInterface';
import Instruction from './Instruction';
export declare function opAdc(state: CpuInterface.State, bus: BusInterface, operand: number): void;
export declare function opAnd(state: CpuInterface.State, bus: BusInterface, operand: number): void;
export declare function opAslAcc(state: CpuInterface.State): void;
export declare function opAslMem(state: CpuInterface.State, bus: BusInterface, operand: number): void;
export declare function opBit(state: CpuInterface.State, bus: BusInterface, operand: number): void;
export declare function opBrk(state: CpuInterface.State, bus: BusInterface): void;
export declare function opClc(state: CpuInterface.State): void;
export declare function opCld(state: CpuInterface.State): void;
export declare function opCli(state: CpuInterface.State): void;
export declare function opClv(state: CpuInterface.State): void;
export declare function opCmp(state: CpuInterface.State, bus: BusInterface, operand: number): void;
export declare function opCpx(state: CpuInterface.State, bus: BusInterface, operand: number): void;
export declare function opCpy(state: CpuInterface.State, bus: BusInterface, operand: number): void;
export declare function opDec(state: CpuInterface.State, bus: BusInterface, operand: number): void;
export declare function opDex(state: CpuInterface.State): void;
export declare function opEor(state: CpuInterface.State, bus: BusInterface, operand: number): void;
export declare function opDey(state: CpuInterface.State): void;
export declare function opInc(state: CpuInterface.State, bus: BusInterface, operand: number): void;
export declare function opInx(state: CpuInterface.State): void;
export declare function opIny(state: CpuInterface.State): void;
export declare function opJmp(state: CpuInterface.State, bus: BusInterface, operand: number): void;
export declare function opJsr(state: CpuInterface.State, bus: BusInterface, operand: number): void;
export declare function opLda(state: CpuInterface.State, bus: BusInterface, operand: number, addressingMode: Instruction.AddressingMode): void;
export declare function opLdx(state: CpuInterface.State, bus: BusInterface, operand: number, addressingMode: Instruction.AddressingMode): void;
export declare function opLdy(state: CpuInterface.State, bus: BusInterface, operand: number, addressingMode: Instruction.AddressingMode): void;
export declare function opLsrAcc(state: CpuInterface.State): void;
export declare function opLsrMem(state: CpuInterface.State, bus: BusInterface, operand: number): void;
export declare function opNop(): void;
export declare function opOra(state: CpuInterface.State, bus: BusInterface, operand: number): void;
export declare function opPhp(state: CpuInterface.State, bus: BusInterface): void;
export declare function opPlp(state: CpuInterface.State, bus: BusInterface): void;
export declare function opPha(state: CpuInterface.State, bus: BusInterface): void;
export declare function opPla(state: CpuInterface.State, bus: BusInterface): void;
export declare function opRolAcc(state: CpuInterface.State): void;
export declare function opRolMem(state: CpuInterface.State, bus: BusInterface, operand: number): void;
export declare function opRorAcc(state: CpuInterface.State): void;
export declare function opRorMem(state: CpuInterface.State, bus: BusInterface, operand: number): void;
export declare function opRti(state: CpuInterface.State, bus: BusInterface): void;
export declare function opRts(state: CpuInterface.State, bus: BusInterface): void;
export declare function opSbc(state: CpuInterface.State, bus: BusInterface, operand: number): void;
export declare function opSec(state: CpuInterface.State): void;
export declare function opSed(state: CpuInterface.State): void;
export declare function opSei(state: CpuInterface.State): void;
export declare function opSta(state: CpuInterface.State, bus: BusInterface, operand: number): void;
export declare function opStx(state: CpuInterface.State, bus: BusInterface, operand: number): void;
export declare function opSty(state: CpuInterface.State, bus: BusInterface, operand: number): void;
export declare function opTax(state: CpuInterface.State): void;
export declare function opTay(state: CpuInterface.State): void;
export declare function opTsx(state: CpuInterface.State): void;
export declare function opTxa(state: CpuInterface.State): void;
export declare function opTxs(state: CpuInterface.State): void;
export declare function opTya(state: CpuInterface.State): void;
export declare function opAlr(state: CpuInterface.State, bus: BusInterface, operand: number): void;
export declare function opAxs(state: CpuInterface.State, bus: BusInterface, operand: number): void;
export declare function opDcp(state: CpuInterface.State, bus: BusInterface, operand: number): void;
export declare function opLax(state: CpuInterface.State, bus: BusInterface, operand: number): void;
export declare function opArr(state: CpuInterface.State, bus: BusInterface, operand: number): void;
export declare function opSlo(state: CpuInterface.State, bus: BusInterface, operand: number): void;
export declare function opAax(state: CpuInterface.State, bus: BusInterface, operand: number): void;
export declare function opLar(state: CpuInterface.State, bus: BusInterface, operand: number): void;
export declare function opIsc(state: CpuInterface.State, bus: BusInterface, operand: number): void;
export declare function opAac(state: CpuInterface.State, bus: BusInterface, operand: number): void;
export declare function opAtx(state: CpuInterface.State, bus: BusInterface, operand: number): void;
export declare function opRra(state: CpuInterface.State, bus: BusInterface, operand: number): void;
export declare function opRla(state: CpuInterface.State, bus: BusInterface, operand: number): void;
