"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.absolute = void 0;
const tslib_1 = require("tslib");
const CpuInterface_1 = tslib_1.__importDefault(require("../../CpuInterface"));
const ResultImpl_1 = tslib_1.__importDefault(require("../ResultImpl"));
const decorators_1 = require("../../../../tools/decorators");
class Absolute {
    constructor(state, next = () => null) {
        this.reset = () => this._result.read(this._fetchLo, this._state.p);
        this._fetchLo = (value) => {
            this._operand = value;
            this._state.p = (this._state.p + 1) & 0xffff;
            return this._result.read(this._fetchHi, this._state.p);
        };
        this._fetchHi = (value) => {
            this._operand |= value << 8;
            this._state.p = (this._state.p + 1) & 0xffff;
            return this._next(this._operand, this._state);
        };
        this._operand = 0;
        this._result = new ResultImpl_1.default();
        this._state = state;
        this._next = next;
        decorators_1.freezeImmutables(this);
    }
}
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Object)
], Absolute.prototype, "reset", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Object)
], Absolute.prototype, "_fetchLo", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Object)
], Absolute.prototype, "_fetchHi", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Object)
], Absolute.prototype, "_result", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", CpuInterface_1.default.State)
], Absolute.prototype, "_state", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Function)
], Absolute.prototype, "_next", void 0);
exports.absolute = (state, next) => new Absolute(state, next);
//# sourceMappingURL=absolute.js.map