import CpuInterface from '../../CpuInterface';
import StateMachineInterface from '../StateMachineInterface';
import NextStep from './NextStep';
declare class AbsoluteIndexed implements StateMachineInterface {
    private constructor();
    static absoluteX(state: CpuInterface.State, next: NextStep, writeOp: boolean): AbsoluteIndexed;
    static absoluteY(state: CpuInterface.State, next: NextStep, writeOp: boolean): AbsoluteIndexed;
    reset: () => StateMachineInterface.Result;
    private _fetchLo;
    private _fetchHi;
    private _dereferenceAndCarry;
    private _operand;
    private _carry;
    private readonly _result;
    private readonly _state;
    private readonly _indexExtractor;
    private readonly _next;
    private readonly _writeOp;
}
declare namespace AbsoluteIndexed {
    interface IndexExtractor {
        (s: CpuInterface.State): number;
    }
}
export declare const absoluteX: (state: CpuInterface.State, next: NextStep, writeOp: boolean) => AbsoluteIndexed;
export declare const absoluteY: (state: CpuInterface.State, next: NextStep, writeOp: boolean) => AbsoluteIndexed;
export {};
