"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.dereference = void 0;
const tslib_1 = require("tslib");
const ResultImpl_1 = tslib_1.__importDefault(require("../ResultImpl"));
const decorators_1 = require("../../../../tools/decorators");
const CpuInterface_1 = tslib_1.__importDefault(require("../../CpuInterface"));
class Dereference {
    constructor(state, next = () => null) {
        this.reset = (operand) => this._result.read(this._dereference, operand);
        this._dereference = (value) => this._next(value, this._state);
        this._result = new ResultImpl_1.default();
        this._next = next;
        this._state = state;
        decorators_1.freezeImmutables(this);
    }
}
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Object)
], Dereference.prototype, "reset", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Object)
], Dereference.prototype, "_dereference", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Object)
], Dereference.prototype, "_result", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", CpuInterface_1.default.State)
], Dereference.prototype, "_state", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Function)
], Dereference.prototype, "_next", void 0);
exports.dereference = (state, next) => new Dereference(state, next);
//# sourceMappingURL=dereference.js.map