"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.immediate = void 0;
const tslib_1 = require("tslib");
const CpuInterface_1 = tslib_1.__importDefault(require("../../CpuInterface"));
const ResultImpl_1 = tslib_1.__importDefault(require("../ResultImpl"));
const decorators_1 = require("../../../../tools/decorators");
class Immediate {
    constructor(state, next = () => null) {
        this.reset = () => this._result.read(this._fetchOperand, this._state.p);
        this._fetchOperand = (value) => {
            this._operand = value;
            this._state.p = (this._state.p + 1) & 0xffff;
            return this._next(this._operand, this._state);
        };
        this._operand = 0;
        this._result = new ResultImpl_1.default();
        this._state = state;
        this._next = next;
        decorators_1.freezeImmutables(this);
    }
}
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Object)
], Immediate.prototype, "reset", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Object)
], Immediate.prototype, "_fetchOperand", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Object)
], Immediate.prototype, "_result", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", CpuInterface_1.default.State)
], Immediate.prototype, "_state", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Function)
], Immediate.prototype, "_next", void 0);
exports.immediate = (state, next) => new Immediate(state, next);
//# sourceMappingURL=immediate.js.map