"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.indexedIndirectX = void 0;
const tslib_1 = require("tslib");
const CpuInterface_1 = tslib_1.__importDefault(require("../../CpuInterface"));
const ResultImpl_1 = tslib_1.__importDefault(require("../ResultImpl"));
const decorators_1 = require("../../../../tools/decorators");
class IndexedIndirectX {
    constructor(state, next = () => null) {
        this.reset = () => this._result.read(this._fetchAddress, this._state.p);
        this._fetchAddress = (value) => {
            this._address = value;
            this._state.p = (this._state.p + 1) & 0xffff;
            return this._result.read(this._addIndex, this._address);
        };
        this._addIndex = (value) => {
            this._address = (this._address + this._state.x) & 0xff;
            return this._result.read(this._fetchLo, this._address);
        };
        this._fetchLo = (value) => {
            this._operand = value;
            this._address = (this._address + 1) & 0xff;
            return this._result.read(this._fetchHi, this._address);
        };
        this._fetchHi = (value) => {
            this._operand |= value << 8;
            return this._next(this._operand, this._state);
        };
        this._operand = 0;
        this._address = 0;
        this._result = new ResultImpl_1.default();
        this._state = state;
        this._next = next;
        decorators_1.freezeImmutables(this);
    }
}
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Object)
], IndexedIndirectX.prototype, "reset", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Object)
], IndexedIndirectX.prototype, "_fetchAddress", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Object)
], IndexedIndirectX.prototype, "_addIndex", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Object)
], IndexedIndirectX.prototype, "_fetchLo", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Object)
], IndexedIndirectX.prototype, "_fetchHi", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Object)
], IndexedIndirectX.prototype, "_result", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", CpuInterface_1.default.State)
], IndexedIndirectX.prototype, "_state", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Function)
], IndexedIndirectX.prototype, "_next", void 0);
exports.indexedIndirectX = (state, next) => new IndexedIndirectX(state, next);
//# sourceMappingURL=indexedIndirectX.js.map