"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.indirect = void 0;
const tslib_1 = require("tslib");
const CpuInterface_1 = tslib_1.__importDefault(require("../../CpuInterface"));
const ResultImpl_1 = tslib_1.__importDefault(require("../ResultImpl"));
const decorators_1 = require("../../../../tools/decorators");
class Indirect {
    constructor(state, next = () => null) {
        this.reset = () => this._result.read(this._fetchAddressLo, this._state.p);
        this._fetchAddressLo = (value) => {
            this._address = value;
            this._state.p = (this._state.p + 1) & 0xffff;
            return this._result.read(this._fetchAddressHi, this._state.p);
        };
        this._fetchAddressHi = (value) => {
            this._address |= value << 8;
            this._state.p = (this._state.p + 1) & 0xffff;
            return this._result.read(this._fetchLo, this._address);
        };
        this._fetchLo = (value) => {
            this._operand = value;
            if ((this._address & 0xff) === 0xff) {
                this._address &= 0xff00;
            }
            else {
                this._address = (this._address + 1) & 0xffff;
            }
            return this._result.read(this._fetchHi, this._address);
        };
        this._fetchHi = (value) => {
            this._operand |= value << 8;
            return this._next(this._operand, this._state);
        };
        this._operand = 0;
        this._address = 0;
        this._result = new ResultImpl_1.default();
        this._state = state;
        this._next = next;
        decorators_1.freezeImmutables(this);
    }
}
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Object)
], Indirect.prototype, "reset", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Object)
], Indirect.prototype, "_fetchAddressLo", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Object)
], Indirect.prototype, "_fetchAddressHi", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Object)
], Indirect.prototype, "_fetchLo", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Object)
], Indirect.prototype, "_fetchHi", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Object)
], Indirect.prototype, "_result", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", CpuInterface_1.default.State)
], Indirect.prototype, "_state", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Function)
], Indirect.prototype, "_next", void 0);
exports.indirect = (state, next) => new Indirect(state, next);
//# sourceMappingURL=indirect.js.map