"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.indirectIndexedY = void 0;
const tslib_1 = require("tslib");
const CpuInterface_1 = tslib_1.__importDefault(require("../../CpuInterface"));
const ResultImpl_1 = tslib_1.__importDefault(require("../ResultImpl"));
const decorators_1 = require("../../../../tools/decorators");
class IndexedIndirectY {
    constructor(state, next = () => null, writeOp) {
        this.reset = () => this._result.read(this._fetchAddress, this._state.p);
        this._fetchAddress = (value) => {
            this._address = value;
            this._state.p = (this._state.p + 1) & 0xffff;
            return this._result.read(this._fetchLo, this._address);
        };
        this._fetchLo = (value) => {
            this._operand = value;
            this._address = (this._address + 1) & 0xff;
            return this._result.read(this._fetchHi, this._address);
        };
        this._fetchHi = (value) => {
            this._operand |= value << 8;
            this._carry = (this._operand & 0xff) + this._state.y > 0xff;
            this._operand = (this._operand & 0xff00) | ((this._operand + this._state.y) & 0xff);
            return this._carry || this._writeOp
                ? this._result.read(this._dereferenceAndCarry, this._operand)
                : this._next(this._operand, this._state);
        };
        this._dereferenceAndCarry = (value) => {
            if (this._carry) {
                this._operand = (this._operand + 0x0100) & 0xffff;
            }
            return this._next(this._operand, this._state);
        };
        this._operand = 0;
        this._address = 0;
        this._carry = false;
        this._result = new ResultImpl_1.default();
        this._state = state;
        this._next = next;
        this._writeOp = writeOp;
        decorators_1.freezeImmutables(this);
    }
}
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Object)
], IndexedIndirectY.prototype, "reset", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Object)
], IndexedIndirectY.prototype, "_fetchAddress", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Object)
], IndexedIndirectY.prototype, "_fetchLo", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Object)
], IndexedIndirectY.prototype, "_fetchHi", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Object)
], IndexedIndirectY.prototype, "_dereferenceAndCarry", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Object)
], IndexedIndirectY.prototype, "_result", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", CpuInterface_1.default.State)
], IndexedIndirectY.prototype, "_state", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Function)
], IndexedIndirectY.prototype, "_next", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Boolean)
], IndexedIndirectY.prototype, "_writeOp", void 0);
exports.indirectIndexedY = (state, next, writeOp) => new IndexedIndirectY(state, next, writeOp);
//# sourceMappingURL=indirectIndexedY.js.map