"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.zeroPageY = exports.zeroPageX = void 0;
const tslib_1 = require("tslib");
const CpuInterface_1 = tslib_1.__importDefault(require("../../CpuInterface"));
const ResultImpl_1 = tslib_1.__importDefault(require("../ResultImpl"));
const decorators_1 = require("../../../../tools/decorators");
class ZeroPageIndexed {
    constructor(state, indexExtractor, next) {
        this.reset = () => this._result.read(this._fetchAddress, this._state.p);
        this._fetchAddress = (value) => {
            this._operand = value;
            this._state.p = (this._state.p + 1) & 0xffff;
            return this._result.read(this._addIndex, this._operand);
        };
        this._addIndex = (value) => {
            this._operand = (this._operand + this._indexExtractor(this._state)) & 0xff;
            return this._next(this._operand, this._state);
        };
        this._operand = 0;
        this._result = new ResultImpl_1.default();
        this._state = state;
        this._indexExtractor = indexExtractor;
        this._next = next;
        decorators_1.freezeImmutables(this);
    }
    static zeroPageX(state, next = () => null) {
        return new ZeroPageIndexed(state, s => s.x, next);
    }
    static zeroPageY(state, next = () => null) {
        return new ZeroPageIndexed(state, s => s.y, next);
    }
}
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Object)
], ZeroPageIndexed.prototype, "reset", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Object)
], ZeroPageIndexed.prototype, "_fetchAddress", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Object)
], ZeroPageIndexed.prototype, "_addIndex", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Object)
], ZeroPageIndexed.prototype, "_result", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", CpuInterface_1.default.State)
], ZeroPageIndexed.prototype, "_state", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Function)
], ZeroPageIndexed.prototype, "_next", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Function)
], ZeroPageIndexed.prototype, "_indexExtractor", void 0);
exports.zeroPageX = (state, next) => ZeroPageIndexed.zeroPageX(state, next);
exports.zeroPageY = (state, next) => ZeroPageIndexed.zeroPageY(state, next);
//# sourceMappingURL=zeroPageIndexed.js.map