"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.branch = void 0;
const tslib_1 = require("tslib");
const CpuInterface_1 = tslib_1.__importDefault(require("../../CpuInterface"));
const ResultImpl_1 = tslib_1.__importDefault(require("../ResultImpl"));
const decorators_1 = require("../../../../tools/decorators");
class Branch {
    constructor(state, predicate) {
        this.reset = () => this._result.read(this._fetchTarget, this._state.p).poll(true);
        this._fetchTarget = (value) => {
            this._operand = value;
            this._state.p = (this._state.p + 1) & 0xffff;
            return this._predicate(this._state.flags) ? this._result.read(this._firstDummyRead, this._state.p) : null;
        };
        this._firstDummyRead = (value) => {
            this._target = (this._state.p + (this._operand & 0x80 ? this._operand - 256 : this._operand)) & 0xffff;
            if ((this._target & 0xff00) === (this._state.p & 0xff00)) {
                this._state.p = this._target;
                return null;
            }
            return this._result.read(this._secondDummyRead, (this._state.p & 0xff00) | (this._target & 0x00ff)).poll(true);
        };
        this._secondDummyRead = (value) => {
            this._state.p = this._target;
            return null;
        };
        this._target = 0;
        this._operand = 0;
        this._result = new ResultImpl_1.default();
        this._state = state;
        this._predicate = predicate;
        decorators_1.freezeImmutables(this);
    }
}
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Object)
], Branch.prototype, "reset", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Object)
], Branch.prototype, "_fetchTarget", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Object)
], Branch.prototype, "_firstDummyRead", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Object)
], Branch.prototype, "_secondDummyRead", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Object)
], Branch.prototype, "_result", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", CpuInterface_1.default.State)
], Branch.prototype, "_state", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Function)
], Branch.prototype, "_predicate", void 0);
exports.branch = (state, predicate) => new Branch(state, predicate);
//# sourceMappingURL=branch.js.map