"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.nullaryOneCycle = void 0;
const tslib_1 = require("tslib");
const CpuInterface_1 = tslib_1.__importDefault(require("../../CpuInterface"));
const ResultImpl_1 = tslib_1.__importDefault(require("../ResultImpl"));
const decorators_1 = require("../../../../tools/decorators");
class NullaryOneCycle {
    constructor(state, operation) {
        this.reset = () => this._result.read(this._executeOperation, this._state.p).poll(true);
        this._executeOperation = () => {
            this._operation(this._state);
            return null;
        };
        this._result = new ResultImpl_1.default();
        this._state = state;
        this._operation = operation;
        decorators_1.freezeImmutables(this);
    }
}
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Object)
], NullaryOneCycle.prototype, "reset", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Object)
], NullaryOneCycle.prototype, "_executeOperation", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Object)
], NullaryOneCycle.prototype, "_result", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", CpuInterface_1.default.State)
], NullaryOneCycle.prototype, "_state", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Function)
], NullaryOneCycle.prototype, "_operation", void 0);
exports.nullaryOneCycle = (state, operation) => new NullaryOneCycle(state, operation);
//# sourceMappingURL=nullaryOneCycle.js.map