"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.pull = void 0;
const tslib_1 = require("tslib");
const decorators_1 = require("../../../../tools/decorators");
const ResultImpl_1 = tslib_1.__importDefault(require("../ResultImpl"));
const CpuInterface_1 = tslib_1.__importDefault(require("../../CpuInterface"));
class Pull {
    constructor(state, operation) {
        this.reset = () => this._result.read(this._dummyRead, this._state.p).poll(true);
        this._dummyRead = () => this._result.read(this._incrementS, 0x0100 + this._state.s);
        this._incrementS = () => {
            this._state.s = (this._state.s + 1) & 0xff;
            return this._result.read(this._pull, 0x0100 + this._state.s);
        };
        this._pull = (value) => (this._operation(this._state, value), null);
        this._result = new ResultImpl_1.default();
        this._state = state;
        this._operation = operation;
        decorators_1.freezeImmutables(this);
    }
}
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Object)
], Pull.prototype, "reset", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Object)
], Pull.prototype, "_dummyRead", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Object)
], Pull.prototype, "_incrementS", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Object)
], Pull.prototype, "_pull", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Object)
], Pull.prototype, "_result", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", CpuInterface_1.default.State)
], Pull.prototype, "_state", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Function)
], Pull.prototype, "_operation", void 0);
exports.pull = (state, operation) => new Pull(state, operation);
//# sourceMappingURL=pull.js.map