"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.push = void 0;
const tslib_1 = require("tslib");
const decorators_1 = require("../../../../tools/decorators");
const CpuInterface_1 = tslib_1.__importDefault(require("../../CpuInterface"));
const ResultImpl_1 = tslib_1.__importDefault(require("../ResultImpl"));
class Push {
    constructor(state, operation) {
        this.reset = () => this._result.read(this._dummyRead, this._state.p);
        this._dummyRead = () => this._result.write(this._push, 0x0100 + this._state.s, this._operation(this._state));
        this._push = () => {
            this._state.s = (this._state.s - 1) & 0xff;
            return null;
        };
        this._result = new ResultImpl_1.default();
        this._state = state;
        this._operation = operation;
        decorators_1.freezeImmutables(this);
    }
}
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Object)
], Push.prototype, "reset", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Object)
], Push.prototype, "_dummyRead", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Object)
], Push.prototype, "_push", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Object)
], Push.prototype, "_result", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", CpuInterface_1.default.State)
], Push.prototype, "_state", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Function)
], Push.prototype, "_operation", void 0);
exports.push = (state, operation) => new Push(state, operation);
//# sourceMappingURL=push.js.map