"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.readModifyWrite = void 0;
const tslib_1 = require("tslib");
const CpuInterface_1 = tslib_1.__importDefault(require("../../CpuInterface"));
const ResultImpl_1 = tslib_1.__importDefault(require("../ResultImpl"));
const decorators_1 = require("../../../../tools/decorators");
class ReadModifyWrite {
    constructor(state, operation) {
        this.reset = (address) => {
            this._address = address;
            return this._result.read(this._read, address);
        };
        this._read = (value) => {
            this._operand = value;
            return this._result.write(this._dummyWrite, this._address, this._operand);
        };
        this._dummyWrite = (value) => this._result.write(this._write, this._address, this._operation(this._operand, this._state));
        this._write = () => null;
        this._result = new ResultImpl_1.default();
        this._state = state;
        this._operation = operation;
        decorators_1.freezeImmutables(this);
    }
}
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Object)
], ReadModifyWrite.prototype, "reset", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Object)
], ReadModifyWrite.prototype, "_read", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Object)
], ReadModifyWrite.prototype, "_dummyWrite", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Object)
], ReadModifyWrite.prototype, "_write", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Object)
], ReadModifyWrite.prototype, "_result", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", CpuInterface_1.default.State)
], ReadModifyWrite.prototype, "_state", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Function)
], ReadModifyWrite.prototype, "_operation", void 0);
exports.readModifyWrite = (state, operation) => new ReadModifyWrite(state, operation);
//# sourceMappingURL=readModifyWrite.js.map