"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.rti = void 0;
const tslib_1 = require("tslib");
const CpuInterface_1 = tslib_1.__importDefault(require("../../CpuInterface"));
const ResultImpl_1 = tslib_1.__importDefault(require("../ResultImpl"));
const decorators_1 = require("../../../../tools/decorators");
class Rti {
    constructor(state) {
        this.reset = () => this._result.read(this._dummyOperandRead, this._state.p);
        this._dummyOperandRead = () => this._result.read(this._dummyStackRead, 0x0100 + this._state.s);
        this._dummyStackRead = () => {
            this._state.s = (this._state.s + 1) & 0xff;
            return this._result.read(this._popP, 0x0100 + this._state.s);
        };
        this._popP = (value) => {
            this._state.flags = (value | 32) & ~16;
            this._state.s = (this._state.s + 1) & 0xff;
            return this._result.read(this._popPcl, 0x0100 + this._state.s);
        };
        this._popPcl = (value) => {
            this._state.p = (this._state.p & 0xff00) | value;
            this._state.s = (this._state.s + 1) & 0xff;
            return this._result.read(this._popPch, 0x0100 + this._state.s);
        };
        this._popPch = (value) => {
            this._state.p = (this._state.p & 0xff) | (value << 8);
            return null;
        };
        this._result = new ResultImpl_1.default();
        this._state = state;
        decorators_1.freezeImmutables(this);
    }
}
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Object)
], Rti.prototype, "reset", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Object)
], Rti.prototype, "_dummyOperandRead", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Object)
], Rti.prototype, "_dummyStackRead", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Object)
], Rti.prototype, "_popP", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Object)
], Rti.prototype, "_popPcl", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Object)
], Rti.prototype, "_popPch", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", Object)
], Rti.prototype, "_result", void 0);
tslib_1.__decorate([
    decorators_1.Immutable,
    tslib_1.__metadata("design:type", CpuInterface_1.default.State)
], Rti.prototype, "_state", void 0);
exports.rti = (state) => new Rti(state);
//# sourceMappingURL=rti.js.map