import VanillaMemory from '../vanilla/Memory';
import SimpleSerialIOInterface from '../io/SimpleSerialIOInterface';
import CpuInterface from '../cpu/CpuInterface';
declare class Memory extends VanillaMemory implements SimpleSerialIOInterface {
    reset(): void;
    setCpu(cpu: CpuInterface): this;
    read(address: number): number;
    readWord(address: number): number;
    write(address: number, value: number): void;
    setInCallback(callback: SimpleSerialIOInterface.InCallbackInterface): Memory;
    getInCallback(): SimpleSerialIOInterface.InCallbackInterface;
    setOutCallback(callback: SimpleSerialIOInterface.OutCallbackInterface): Memory;
    getOutCallback(): SimpleSerialIOInterface.OutCallbackInterface;
    private _inCallback;
    private _outCallback;
    private _cpu;
    private _feedbackRegister;
}
export { Memory as default };
