import { EventInterface } from 'microevent.ts';
import AudioOutputBuffer from '../../tools/AudioOutputBuffer';
interface PCMAudioOutputInterface {
    getSampleRate(): number;
    getFrameSize(): number;
    setFrameBufferFactory(factory: PCMAudioOutputInterface.FrameBufferFactory): void;
    isPaused(): boolean;
    newFrame: EventInterface<AudioOutputBuffer>;
    togglePause: EventInterface<boolean>;
}
declare namespace PCMAudioOutputInterface {
    interface FrameBufferFactory {
        (): AudioOutputBuffer;
    }
}
export { PCMAudioOutputInterface as default };
