"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const microevent_ts_1 = require("microevent.ts");
class Switch {
    constructor(_state = false) {
        this._state = _state;
        this.stateChanged = new microevent_ts_1.Event();
        this.beforeRead = new microevent_ts_1.Event();
    }
    read() {
        this.beforeRead.dispatch(this);
        return this._state;
    }
    peek() {
        return this._state;
    }
    toggle(state) {
        if (this._state === state) {
            return;
        }
        this._state = state;
        this.stateChanged.dispatch(state);
    }
}
exports.default = Switch;
//# sourceMappingURL=Switch.js.map