import CpuFactory from '../cpu/Factory';
interface Config {
    tvMode: Config.TvMode;
    enableAudio: boolean;
    randomSeed: number;
    emulatePaddles: boolean;
    frameStart: number;
    pcmAudio: boolean;
    cpuType: CpuFactory.Type;
}
declare namespace Config {
    const enum TvMode {
        ntsc = 0,
        pal = 1,
        secam = 2
    }
    function create(config?: Partial<Config>): Config;
    function getClockHz(config: Config): number;
}
export { Config as default };
