"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = void 0;
const tslib_1 = require("tslib");
const microevent_ts_1 = require("microevent.ts");
const CartridgeInterface_1 = tslib_1.__importDefault(require("./CartridgeInterface"));
const CartridgeInfo_1 = tslib_1.__importDefault(require("./CartridgeInfo"));
class AbstractCartridge {
    constructor() {
        this.trap = new microevent_ts_1.Event();
    }
    init() {
        return tslib_1.__awaiter(this, void 0, void 0, function* () { });
    }
    reset() { }
    read(address) {
        return 0;
    }
    peek(address) {
        return this.read(address);
    }
    write(address, value) { }
    getType() {
        return CartridgeInfo_1.default.CartridgeType.unknown;
    }
    setCpu(cpu) {
        return this;
    }
    setBus(bus) {
        return this;
    }
    setRng(rng) {
        return this;
    }
    setCpuTimeProvider(provider) {
        return this;
    }
    notifyCpuCycleComplete() { }
    randomize(rng) { }
    triggerTrap(reason, message) {
        if (this.trap.hasHandlers) {
            this.trap.dispatch(new CartridgeInterface_1.default.TrapPayload(reason, this, message));
        }
        else {
            throw new Error(message);
        }
    }
}
exports.default = AbstractCartridge;
//# sourceMappingURL=AbstractCartridge.js.map