import AbstractCartridge from './AbstractCartridge';
import * as cartridgeUtil from './util';
import CartridgeInfo from './CartridgeInfo';
import Bus from '../Bus';
import RngInterface from '../../../tools/rng/GeneratorInterface';
declare class Cartridge3E extends AbstractCartridge {
    constructor(buffer: cartridgeUtil.BufferInterface);
    static matchesBuffer(buffer: cartridgeUtil.BufferInterface): boolean;
    reset(): void;
    randomize(rng: RngInterface): void;
    setBus(bus: Bus): this;
    read(address: number): number;
    peek(address: number): number;
    write(address: number, value: number): void;
    getType(): CartridgeInfo.CartridgeType;
    private static _onBusAccess;
    private _banks;
    private _bank0;
    private _bank1;
    private _ramSelect;
    private _ramBanks;
    private _ramBank;
    private _bus;
}
export { Cartridge3E as default };
