"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = void 0;
const tslib_1 = require("tslib");
const AbstractCartridge_1 = tslib_1.__importDefault(require("./AbstractCartridge"));
const CartridgeInfo_1 = tslib_1.__importDefault(require("./CartridgeInfo"));
class Cartridge4k extends AbstractCartridge_1.default {
    constructor(buffer) {
        super();
        this._rom = new Uint8Array(0x1000);
        if (buffer.length !== 0x1000) {
            console.warn(`buffer has invalid size for 4K image: ${buffer.length} bytes`);
        }
        const len = Math.min(0x1000, buffer.length);
        for (let i = 0; i < 0x1000 && i < buffer.length; i++) {
            this._rom[0x0fff - i] = buffer[len - 1 - i];
        }
    }
    read(address) {
        return this._rom[address & 0x0fff];
    }
    getType() {
        return CartridgeInfo_1.default.CartridgeType.vanilla_4k;
    }
}
exports.default = Cartridge4k;
//# sourceMappingURL=Cartridge4k.js.map