import AbstractCartridge from './AbstractCartridge';
import CartridgeInfo from './CartridgeInfo';
import RngGeneratorInterface from '../../../tools/rng/GeneratorInterface';
import Bus from '../Bus';
import { BufferInterface } from './util';
declare class CartridgeCV extends AbstractCartridge {
    constructor(buffer: {
        [i: number]: number;
        length: number;
    });
    static matchesBuffer(buffer: BufferInterface): boolean;
    setBus(bus: Bus): this;
    randomize(rng: RngGeneratorInterface): void;
    read(address: number): number;
    write(address: number, value: number): void;
    peek(address: number): number;
    getType(): CartridgeInfo.CartridgeType;
    private _rom;
    private _ram;
    private _bus;
}
export default CartridgeCV;
