import AbstractCartridge from './AbstractCartridge';
import CartridgeInfo from './CartridgeInfo';
import Bus from '../Bus';
import * as cartridgeUtil from './util';
declare class CartridgeDPC extends AbstractCartridge {
    constructor(buffer: cartridgeUtil.BufferInterface);
    reset(): void;
    getType(): CartridgeInfo.CartridgeType;
    setBus(bus: Bus): this;
    setCpuTimeProvider(provider: () => number): this;
    read(address: number): number;
    peek(address: number): number;
    write(address: number, value: number): void;
    private _access;
    private _randomNext;
    private _clockMusicFetchers;
    private _bank0;
    private _bank1;
    private _bank;
    private _fetcherData;
    private _fetchers;
    private _rng;
    private _bus;
    private _cpuTimeProvider;
    private _lastCpuTime;
    private _clockAccumulator;
}
export { CartridgeDPC as default };
