import AbstractCartridge from './AbstractCartridge';
import CartridgeInfo from './CartridgeInfo';
import Bus from '../Bus';
import * as cartridgeUtil from './util';
import RngInterface from '../../../tools/rng/GeneratorInterface';
declare class CartridgeEF extends AbstractCartridge {
    private _supportSC;
    constructor(buffer: {
        [i: number]: number;
        length: number;
    }, _supportSC?: boolean);
    static matchesBuffer(buffer: cartridgeUtil.BufferInterface): boolean;
    reset(): void;
    getType(): CartridgeInfo.CartridgeType;
    randomize(rng: RngInterface): void;
    setBus(bus: Bus): this;
    read(address: number): number;
    peek(address: number): number;
    write(address: number, value: number): void;
    private _access;
    private _bus;
    private _bank;
    private _banks;
    private _ram;
    private _hasSC;
}
export { CartridgeEF as default };
