import AbstractCartridge from './AbstractCartridge';
import CartridgeInfo from './CartridgeInfo';
import Bus from '../Bus';
import RngInterface from '../../../tools/rng/GeneratorInterface';
declare class CartridgeF6 extends AbstractCartridge {
    private _supportSC;
    constructor(buffer: {
        [i: number]: number;
        length: number;
    }, _supportSC?: boolean);
    reset(): void;
    read(address: number): number;
    peek(address: number): number;
    write(address: number, value: number): void;
    getType(): CartridgeInfo.CartridgeType;
    randomize(rng: RngInterface): void;
    setBus(bus: Bus): this;
    private _access;
    private _bank;
    private _bank0;
    private _bank1;
    private _bank2;
    private _bank3;
    private _hasSC;
    private _saraRAM;
    private _bus;
}
export { CartridgeF6 as default };
