import AbstractCartridge from './AbstractCartridge';
import CartridgeInfo from './CartridgeInfo';
import Bus from '../Bus';
import * as cartridgeUtil from './util';
import RngInterface from '../../../tools/rng/GeneratorInterface';
declare class CartridgeF8 extends AbstractCartridge {
    private _supportSC;
    constructor(buffer: cartridgeUtil.BufferInterface, _supportSC?: boolean);
    static matchesBuffer(buffer: cartridgeUtil.BufferInterface): boolean;
    reset(): void;
    read(address: number): number;
    peek(address: number): number;
    write(address: number, value: number): void;
    getType(): CartridgeInfo.CartridgeType;
    randomize(rng: RngInterface): void;
    setBus(bus: Bus): this;
    private _access;
    private _bank;
    private _bank0;
    private _bank1;
    private _hasSC;
    private _saraRAM;
    private _bus;
}
export { CartridgeF8 as default };
