import AbstractCartridge from './AbstractCartridge';
import CartridgeInfo from './CartridgeInfo';
import RngInterface from '../../../tools/rng/GeneratorInterface';
import Bus from '../Bus';
import * as cartridgeUtil from './util';
declare class CartridgeFA2 extends AbstractCartridge {
    constructor(buffer: cartridgeUtil.BufferInterface);
    static matchesBuffer(buffer: cartridgeUtil.BufferInterface): boolean;
    reset(): void;
    getType(): CartridgeInfo.CartridgeType;
    randomize(rng: RngInterface): void;
    setBus(bus: Bus): this;
    read(address: number): number;
    peek(address: number): number;
    write(address: number, value: number): void;
    private _handleIo;
    private _bank;
    private _banks;
    private _ram;
    private _savedRam;
    private _accessCounter;
    private _accessCounterLimit;
    private _bus;
}
export { CartridgeFA2 as default };
