import AbstractCartridge from './AbstractCartridge';
import CartridgeInfo from './CartridgeInfo';
import RngInterface from '../../../tools/rng/GeneratorInterface';
import Bus from '../Bus';
import { BufferInterface } from './util';
declare class CartridgePP extends AbstractCartridge {
    constructor(buffer: BufferInterface);
    getType(): CartridgeInfo.CartridgeType;
    reset(): void;
    randomize(rng: RngInterface): void;
    setBus(bus: Bus): this;
    read(address: number): number;
    write(address: number, value: number): void;
    peek(address: number): number;
    private static _onBusAccess;
    private _access;
    private _switchLayout;
    private _configureSegments;
    private _banks;
    private _segments;
    private _ram;
    private _bus;
    private _bankSwitchPending;
    private _pendingBank;
    private _accessCounter;
    private _previousAddressBusValue;
}
export default CartridgePP;
