import AbstractCartridge from './AbstractCartridge';
import CartridgeInfo from './CartridgeInfo';
import Bus from '../Bus';
import RngInterface from '../../../tools/rng/GeneratorInterface';
declare class CartridgeSupercharger extends AbstractCartridge {
    constructor(buffer: {
        [i: number]: number;
        length: number;
    });
    reset(): void;
    setBus(bus: Bus): this;
    setCpuTimeProvider(provider: () => number): this;
    setRng(rng: RngInterface): this;
    read(address: number): number;
    peek(address: number): number;
    write(address: number, value: number): void;
    getType(): CartridgeInfo.CartridgeType;
    private static _onBusAccess;
    private _access;
    private _setBankswitchMode;
    private _configureBanks;
    private _setupRom;
    private _loadIntoRam;
    private _bus;
    private _loadCount;
    private _loads;
    private _headers;
    private _rom;
    private _ramBanks;
    private _bank0;
    private _bank1;
    private _bank1Type;
    private _transitionCount;
    private _pendingWriteData;
    private _pendingWrite;
    private _lastAddressBusValue;
    private _writeRamEnabled;
    private _loadInProgress;
    private _loadTimestamp;
    private _rng;
    private _cpuTimeProvider;
}
export { CartridgeSupercharger as default };
