import Thumbulator from 'thumbulator.ts';
import { Event } from 'microevent.ts';
declare class Soc {
    constructor(blx32Handler?: Soc.Blx32Handler);
    init(): Promise<void>;
    reset(): void;
    getRom(): Uint8Array;
    getRam(): Uint8Array;
    run(entry: number): void;
    getThumbulator(): Thumbulator;
    private _triggerTrap;
    getRom16: (address: number) => number;
    getRom32: (address: number) => number;
    getRam16: (address: number) => number;
    getRam32: (address: number) => number;
    setRam16: (address: number, value: number) => void;
    setRam32: (address: number, value: number) => void;
    trap: Event<string>;
    private _thumbulatorBus;
    private _romBuffer;
    private _rom8;
    private _rom16;
    private _rom32;
    private _ramBuffer;
    private _ram8;
    private _ram16;
    private _ram32;
    private _armMamcr;
    private _thumbulator;
}
declare namespace Soc {
    interface Blx32Handler {
        (address: number, targetAddress: number): number;
    }
}
export { Soc as default };
