"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.searchForSignature = exports.searchForSignatures = void 0;
function searchForSignatures(buffer, signatures) {
    const candidates = [], counts = signatures.map((signature) => 0);
    for (let i = 0; i < buffer.length; i++) {
        for (let iCandidate = 0; iCandidate < candidates.length; iCandidate++) {
            const candidate = candidates[iCandidate], signature = signatures[candidate.signature];
            if (buffer[i] === signature[candidate.nextIndex]) {
                if (++candidate.nextIndex === signature.length) {
                    counts[candidate.signature]++;
                    candidates.splice(iCandidate, 1);
                    iCandidate--;
                }
            }
            else {
                candidates.splice(iCandidate, 1);
                iCandidate--;
            }
        }
        for (let iSignature = 0; iSignature < signatures.length; iSignature++) {
            const signature = signatures[iSignature];
            if (signature.length > 0 && buffer[i] === signature[0]) {
                if (signature.length === 1) {
                    counts[iSignature]++;
                }
                else {
                    candidates.push({
                        signature: iSignature,
                        nextIndex: 1
                    });
                }
            }
        }
    }
    return counts;
}
exports.searchForSignatures = searchForSignatures;
function searchForSignature(buffer, signature) {
    for (let i = 0; i < buffer.length; i++) {
        let j;
        for (j = 0; j < signature.length && (buffer[i + j] === signature[j] || signature[j] < 0); j++) { }
        if (j === signature.length) {
            return i;
        }
    }
    return -1;
}
exports.searchForSignature = searchForSignature;
//# sourceMappingURL=util.js.map