"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class LatchedInput {
    constructor(_switch) {
        this._switch = _switch;
        this._modeLatched = false;
        this._latchedValue = 0;
        this.reset();
    }
    reset() {
        this._modeLatched = false;
        this._latchedValue = 0;
    }
    vblank(value) {
        if (value & 0x40) {
            this._modeLatched = true;
        }
        else {
            this._modeLatched = false;
            this._latchedValue = 0x80;
        }
    }
    inpt() {
        let value = this._switch.read() ? 0 : 0x80;
        if (this._modeLatched) {
            this._latchedValue &= value;
            value = this._latchedValue;
        }
        return value;
    }
}
exports.default = LatchedInput;
//# sourceMappingURL=LatchedInput.js.map