import { Event } from 'microevent.ts';
import PCMAudioInterface from '../../io/PCMAudioOutputInterface';
import AudioInterface from './AudioInterface';
import AudioOutputBuffer from '../../../tools/AudioOutputBuffer';
import StellaConfig from '../Config';
export declare namespace __init {
}
declare class PCMAudio implements PCMAudioInterface {
    private _config;
    constructor(_config: StellaConfig);
    getChannels(): Array<AudioInterface>;
    reset(): void;
    tick(): void;
    isPaused(): boolean;
    setActive(isActive: boolean): void;
    getSampleRate(): number;
    getFrameSize(): number;
    setFrameBufferFactory(factory: PCMAudioInterface.FrameBufferFactory): void;
    private _dispatchBuffer;
    newFrame: Event<AudioOutputBuffer>;
    togglePause: Event<boolean>;
    private _currentOutputBuffer;
    private _bufferIndex;
    private _sampleRate;
    private _frameSize;
    private _counter;
    private _isActive;
    private _bufferFactory;
    private _channel0;
    private _channel1;
}
export { PCMAudio as default };
