import { Event } from 'microevent.ts';
import AudioOutputBuffer from '../../../tools/AudioOutputBuffer';
import WaveformAudioOutputInterface from '../../io/WaveformAudioOutputInterface';
import Config from '../Config';
import AudioInterface from './AudioInterface';
export default class WaveformAudio implements WaveformAudioOutputInterface, AudioInterface {
    private _config;
    constructor(_config: Config);
    reset(): void;
    audc(value: number): void;
    audf(value: number): void;
    audv(value: number): void;
    setActive(active: boolean): void;
    getVolume(): number;
    getBuffer(key: number): AudioOutputBuffer;
    protected _getKey(): number;
    protected _dispatchBufferChanged(): void;
    bufferChanged: Event<number>;
    volumeChanged: Event<number>;
    stop: Event<void>;
    private _volume;
    private _tone;
    private _frequency;
    private _active;
    private _toneGenerator;
}
