"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = void 0;
class Memory {
    constructor() {
        this._data = new Uint8Array(0x10000);
        this.clear();
    }
    reset() { }
    clear() {
        for (let i = 0; i < 0x10000; i++) {
            this._data[i] = 0;
        }
    }
    read(address) {
        return this._data[address];
    }
    peek(address) {
        return this._data[address];
    }
    readWord(address) {
        return this._data[address] + (this._data[(address + 1) & 0xffff] << 8);
    }
    write(address, value) {
        this._data[address] = value;
    }
    poke(address, value) {
        this._data[address] = value;
    }
}
exports.default = Memory;
//# sourceMappingURL=Memory.js.map