"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class Throttle {
    constructor(_interval, _callback) {
        this._interval = _interval;
        this._callback = _callback;
        this._handle = null;
        this._lastCall = Date.now();
    }
    run(data) {
        this._data = data;
        if (this._handle !== null)
            return;
        const ts = Date.now();
        if (ts - this._lastCall >= this._interval) {
            this._lastCall = ts;
            this._callback(this._data);
        }
        else {
            this._handle = window.setTimeout(() => {
                this._handle = null;
                this._lastCall = ts;
                this._callback(this._data);
            }, this._interval - ts + this._lastCall);
        }
    }
}
exports.default = Throttle;
//# sourceMappingURL=Throttle.js.map