"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Immutable = exports.freezeImmutables = void 0;
const immutables = Symbol('immutable properties');
function freezeImmutables(target) {
    const immutableProperties = target[immutables];
    if (!immutableProperties) {
        return;
    }
    for (const prop of immutableProperties) {
        Object.defineProperty(target, prop, { writable: false, configurable: false });
    }
}
exports.freezeImmutables = freezeImmutables;
function Immutable(target, prop) {
    if (!target[immutables]) {
        Object.defineProperty(target, immutables, { value: [], writable: false, enumerable: false });
    }
    target[immutables].push(prop);
}
exports.Immutable = Immutable;
//# sourceMappingURL=decorators.js.map