"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = void 0;
const tslib_1 = require("tslib");
const InducedMember_1 = tslib_1.__importDefault(require("./InducedMember"));
class InducedPool {
    constructor(_mapper, _adopter = () => {
        throw new Error('adopt is not supported');
    }) {
        this._mapper = _mapper;
        this._adopter = _adopter;
        this._map = new WeakMap();
    }
    get(original) {
        if (!this._map.has(original)) {
            this._map.set(original, new InducedMember_1.default(original, this._mapper, this._adopter));
        }
        return this._map.get(original);
    }
}
exports.default = InducedPool;
//# sourceMappingURL=InducedPool.js.map