import { Event } from 'microevent.ts';
import PoolMember from './PoolMember';
import PoolInterface from './PoolInterface';
declare class Pool<T> implements PoolInterface<T> {
    private _factory;
    constructor(_factory: Pool.FactoryInterface<T>);
    get(): PoolMember<T>;
    private _releaseMember;
    private _disposeMember;
    event: {
        release: Event<T>;
        dispose: Event<T>;
    };
    private _pool;
    private _poolSize;
}
declare namespace Pool {
    interface FactoryInterface<T> {
        (): T;
    }
}
export { Pool as default };
