"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = void 0;
class PeriodicScheduler {
    constructor(_period) {
        this._period = _period;
    }
    setPeriod(period) {
        this._period = period;
        return this;
    }
    getPeriod() {
        return this._period;
    }
    start(worker, context) {
        let terminate = false;
        const handler = () => {
            if (terminate) {
                return;
            }
            worker(context);
            setTimeout(handler, this._period);
        };
        setTimeout(handler, this._period);
        return {
            stop: () => (terminate = true)
        };
    }
}
exports.default = PeriodicScheduler;
//# sourceMappingURL=PeriodicScheduler.js.map