"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = void 0;
const tslib_1 = require("tslib");
const getTimestamp_1 = tslib_1.__importDefault(require("../getTimestamp"));
const setImmediate_1 = require("../setImmediate");
const SAFETY_FACTOR = 3;
class ConstantTimesliceScheduler {
    start(worker, context, _timeSlice) {
        const timeSlice = _timeSlice || 100;
        let timestamp0 = getTimestamp_1.default(), emulationTime = 0, running = true;
        function handler() {
            if (!running) {
                return;
            }
            const timestamp = getTimestamp_1.default();
            let delta = timestamp - timestamp0 - emulationTime;
            if (delta > SAFETY_FACTOR * timeSlice) {
                delta = SAFETY_FACTOR * timeSlice;
                timestamp0 = timestamp - delta;
                emulationTime = 0;
            }
            emulationTime += worker(context, delta);
            const timeToSleep = timeSlice - getTimestamp_1.default() + timestamp;
            if (timeToSleep > 0) {
                setTimeout(handler, timeToSleep);
            }
            else {
                setImmediate_1.setImmediate(handler);
            }
        }
        setImmediate_1.setImmediate(handler);
        return { stop: () => (running = false) };
    }
}
exports.default = ConstantTimesliceScheduler;
//# sourceMappingURL=ConstantTimeslice.js.map