"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const microevent_ts_1 = require("microevent.ts");
class AsyncIO {
    constructor() {
        this.message = new microevent_ts_1.Event();
        this._io = null;
    }
    bind(io) {
        if (this._io) {
            return;
        }
        if (io) {
            io.message.addHandler(AsyncIO._onAsyncIOMessage, this);
        }
        this._io = io;
    }
    unbind() {
        if (!this._io) {
            return;
        }
        this._io.message.removeHandler(AsyncIO._onAsyncIOMessage, this);
        this._io = null;
    }
    send(message) {
        if (this._io) {
            this._io.send(message);
        }
    }
    static _onAsyncIOMessage(message, self) {
        self.message.dispatch(message);
    }
}
exports.default = AsyncIO;
//# sourceMappingURL=AsyncIO.js.map