"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class MouseAsPaddleDriver {
    constructor() {
        this._x = -1;
        this._listener = this._onDocumentMouseMove.bind(this);
    }
    bind(paddle) {
        if (this._paddle) {
            return;
        }
        this._paddle = paddle;
        this._x = -1;
        document.addEventListener('mousemove', this._listener);
    }
    unbind() {
        if (!this._paddle) {
            return;
        }
        document.removeEventListener('mousemove', this._listener);
        this._paddle = null;
    }
    _onDocumentMouseMove(e) {
        if (this._x >= 0) {
            const dx = e.screenX - this._x;
            let value = this._paddle.getValue();
            value += -dx / window.innerWidth / 0.9;
            if (value < 0) {
                value = 0;
            }
            if (value > 1) {
                value = 1;
            }
            this._paddle.setValue(value);
        }
        this._x = e.screenX;
    }
}
exports.default = MouseAsPaddleDriver;
//# sourceMappingURL=MouseAsPaddle.js.map