import { Event } from 'microevent.ts';
import PoolMemberInterface from '../../tools/pool/PoolMemberInterface';
import PCMAudioEndpointInterface from './PCMAudioEndpointInterface';
import PCMAudioOutputInterface from '../../machine/io/PCMAudioOutputInterface';
declare class PCMAudioEndpoint implements PCMAudioEndpointInterface {
    private _output;
    constructor(_output: PCMAudioOutputInterface);
    getSampleRate(): number;
    getFrameSize(): number;
    isPaused(): boolean;
    newFrame: Event<PoolMemberInterface<Float32Array>>;
    togglePause: Event<boolean>;
    private _audioBufferPool;
    private _audioBufferMap;
    private _pcmDataPool;
}
export { PCMAudioEndpoint as default };
