import WaveformAudioOutputInterface from '../../machine/io/WaveformAudioOutputInterface';
import PCMAudioEndpointInterface from './PCMAudioEndpointInterface';
declare class WebAudioDriver {
    constructor(waveformChannels?: number, pcmChannels?: number, fragmentSize?: number);
    init(): void;
    bind(waveformSources?: Array<WaveformAudioOutputInterface>, pcmSources?: Array<PCMAudioEndpointInterface>): void;
    unbind(): void;
    setMasterVolume(channel: number, volume: number): void;
    pause(): Promise<void>;
    resume(): Promise<void>;
    close(): void;
    private _touchListener;
    private _context;
    private _merger;
    private _waveformChannels;
    private _pcmChannels;
    private _channels;
    private _cache;
    private _mutex;
    private _suspended;
    private _isBound;
}
export { WebAudioDriver as default };
