"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = void 0;
class LinearReasmpler {
    constructor() {
        this._buffer = new Float32Array(2);
        this._fractionalIndex = 0;
        this._needsData = false;
        this._ratio = 0;
        this.reset(1, 1);
    }
    reset(sourceRate, targetRate) {
        this._ratio = sourceRate / targetRate;
        this._needsData = false;
        this._fractionalIndex = 0;
        for (let i = 0; i < 2; i++) {
            this._buffer[i] = 0;
        }
    }
    get() {
        const x = (1 - this._fractionalIndex) * this._buffer[0] + this._fractionalIndex * this._buffer[1];
        this._fractionalIndex += this._ratio;
        if (this._fractionalIndex > 1) {
            this._fractionalIndex -= 1;
            this._needsData = true;
        }
        return x;
    }
    push(sample) {
        this._buffer[0] = this._buffer[1];
        this._buffer[1] = sample;
        this._needsData = false;
    }
    needsData() {
        return this._needsData;
    }
}
exports.default = LinearReasmpler;
//# sourceMappingURL=LinearResampler.js.map