import ChannelInterface from './ChannelInterface';
import WaveformAudioOutputInterface from '../../../machine/io/WaveformAudioOutputInterface';
declare class WaveformChannel implements ChannelInterface {
    private _cache;
    constructor(_cache: Map<number, AudioBuffer>);
    init(context: AudioContext, target: AudioNode): void;
    bind(target: WaveformAudioOutputInterface): void;
    unbind(): void;
    setMasterVolume(volume: number): void;
    private static _onVolumeChanged;
    private static _onBufferChanged;
    private static _onStop;
    private _updateGain;
    private _context;
    private _source;
    private _gain;
    private _audio;
    private _volume;
    private _masterVolume;
}
export { WaveformChannel as default };
