export declare const enum Target {
    left = "left",
    right = "right",
    up = "up",
    down = "down",
    fire = "fire",
    start = "start",
    select = "select",
    pause = "pause"
}
export declare const enum MappingType {
    button = "button",
    axis = "axis"
}
export declare const enum Sign {
    positive = "positive",
    negative = "negative"
}
export interface ButtonMapping {
    type: MappingType.button;
    index: number;
    target: Target;
}
export interface AxisMapping {
    type: MappingType.axis;
    index: number;
    sign: Sign;
    target: Target;
}
export declare type Mapping = ButtonMapping | AxisMapping;
export declare function button(index: number, target: Target): ButtonMapping;
export declare function axis(index: number, sign: Sign, target: Target): AxisMapping;
export default Mapping;
