import Processor from './Processor';
import { Capabilities } from './Capabilities';
declare class NtscProcessor implements Processor {
    private _gl;
    private _capabilities;
    constructor(_gl: WebGLRenderingContext, _capabilities: Capabilities);
    init(): void;
    destroy(): void;
    render(texture: WebGLTexture): void;
    getWidth(): number;
    getHeight(): number;
    getTexture(): WebGLTexture;
    resize(width: number, height: number): void;
    configure(mode: NtscProcessor.mode): void;
    private _pass;
    private _textureType;
    private _height;
    private _programPass1;
    private _programPass2;
    private _targetPass1;
    private _targetPass2;
    private _framebuffer;
    private _vertexCoordinateBuffer;
    private _textureCoordinateBuffer;
    private _initialized;
}
declare namespace NtscProcessor {
    const enum mode {
        composite = "composite",
        svideo = "svideo"
    }
}
export default NtscProcessor;
