import { Capabilities } from './Capabilities';
export declare namespace vsh {
    namespace plain {
        const source: (capabilities: Capabilities) => string;
        const enum attribute {
            vertexPosition = "a_VertexPosition",
            textureCoordinate = "a_TextureCoordinate"
        }
    }
}
export declare namespace fsh {
    namespace blit {
        const source: (capabilities: Capabilities) => string;
        const enum uniform {
            textureUnit = "u_Sampler0"
        }
    }
    namespace blitWithGamma {
        const source: (capabilities: Capabilities) => string;
        const enum uniform {
            textureUnit = "u_Sampler0",
            gamma = "u_Gamma"
        }
    }
    namespace phosphor {
        const source: (capabilities: Capabilities) => string;
        const enum uniform {
            level = "u_PhosphorLevel",
            textureUnitNew = "u_Sampler_NewImage",
            textureUnitPrevious = "u_Sampler_PreviousImage"
        }
    }
    namespace ntscPass1 {
        const source: (capabilities: Capabilities) => string;
        const enum uniform {
            textureUnit = "u_Sampler0",
            artifacting = "u_Artifacting",
            fringing = "u_Fringing"
        }
    }
    namespace ntscPass2 {
        const source: (capabilities: Capabilities) => string;
        const enum uniform {
            textureUnit = "u_Sampler0"
        }
    }
    namespace scanlines {
        const source: (capabilities: Capabilities) => string;
        const enum uniform {
            textureUnit = "u_Sampler0",
            level = "u_Level",
            height = "u_Height"
        }
    }
}
