"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const async_mutex_1 = require("async-mutex");
const Stellerator_1 = tslib_1.__importDefault(require("./Stellerator"));
const STYLES = `
    :host {
        display: block;
    }

    canvas {
        width: 100%;
        height: 100%;
    }
`;
const PRIVATES = new WeakMap();
class Prv {
    constructor() {
        this.srcMutex = new async_mutex_1.Mutex();
    }
}
function prv(self) {
    if (!PRIVATES.has(self)) {
        PRIVATES.set(self, new Prv());
    }
    return PRIVATES.get(self);
}
class StelleratorComponent extends HTMLElement {
    constructor() {
        super();
        const shadow = this.attachShadow({ mode: 'open' });
        const style = document.createElement('style');
        style.innerText = STYLES;
        const canvas = document.createElement('canvas');
        shadow.appendChild(canvas);
        shadow.appendChild(style);
        prv(this).stellerator = new Stellerator_1.default(canvas, this.getAttribute('worker') || 'stellerator.min.js');
        this.src = this.getAttribute('src');
    }
    set src(url) {
        prv(this).src = url;
        if (!url) {
            return;
        }
        prv(this).srcMutex.runExclusive(() => tslib_1.__awaiter(this, void 0, void 0, function* () {
            const response = yield fetch(url);
            prv(this).stellerator.run(new Uint8Array(yield response.arrayBuffer()), this.getAttribute('tv-mode') || Stellerator_1.default.TvMode.ntsc);
        }));
    }
}
try {
    customElements.define('stellerator-emu', StelleratorComponent);
}
catch (e) {
    console.warn(`Enable to define custom element: ${e.message}. <stellerator/> will not be  available`);
}
//# sourceMappingURL=Component.js.map