"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = void 0;
const tslib_1 = require("tslib");
const SwitchProxy_1 = tslib_1.__importDefault(require("./SwitchProxy"));
class ControlPanelProxy {
    constructor() {
        this._reset = new SwitchProxy_1.default();
        this._select = new SwitchProxy_1.default();
        this._difficultyPlayer1 = new SwitchProxy_1.default();
        this._difficultyPlayer2 = new SwitchProxy_1.default();
        this._color = new SwitchProxy_1.default();
        this._boundControlPanel = null;
    }
    bind(controlPanel) {
        this.unbind();
        this._boundControlPanel = controlPanel;
        this._reset.bind(this._boundControlPanel.getResetButton());
        this._select.bind(this._boundControlPanel.getSelectSwitch());
        this._difficultyPlayer1.bind(this._boundControlPanel.getDifficultySwitchP0());
        this._difficultyPlayer2.bind(this._boundControlPanel.getDifficultySwitchP1());
        this._color.bind(this._boundControlPanel.getColorSwitch());
        this._difficultyPlayer1.toggle(true);
        this._difficultyPlayer2.toggle(true);
    }
    unbind() {
        if (!this._boundControlPanel) {
            return;
        }
        this._reset.unbind();
        this._select.unbind();
        this._difficultyPlayer1.unbind();
        this._difficultyPlayer2.unbind();
        this._color.unbind();
        this._boundControlPanel = null;
    }
    reset() {
        return this._reset;
    }
    select() {
        return this._select;
    }
    difficultyPlayer1() {
        return this._difficultyPlayer1;
    }
    difficultyPlayer2() {
        return this._difficultyPlayer2;
    }
    color() {
        return this._color;
    }
}
exports.default = ControlPanelProxy;
//# sourceMappingURL=ControlPanelProxy.js.map