import { Event } from 'microevent.ts';
import DigitalJoystickInterface from '../../../machine/io/DigitalJoystickInterface';
import ControlPanelInterface from '../../../machine/stella/ControlPanelInterface';
declare class TouchIO {
    private _canvas;
    private _joystickSensitivity;
    private _leftHanded;
    constructor(_canvas: HTMLCanvasElement, _joystickSensitivity?: number, _leftHanded?: boolean);
    static isSupported(): boolean;
    bind(joystick: DigitalJoystickInterface, controlPanel: ControlPanelInterface): void;
    unbind(): void;
    private _bindListeners;
    private _unbindListeners;
    private _onTouchStart;
    private _onTouchEnd;
    private _onTouchMove;
    toggleFullscreen: Event<void>;
    togglePause: Event<void>;
    private _fullscreenDoubleTapDetector;
    private _bound;
    private _joystick;
    private _select;
    private _reset;
    private _isAlt;
    private _pendingTouches;
}
export default TouchIO;
