import WaveformAudioOutputInterface from '../../../machine/io/WaveformAudioOutputInterface';
import PCMAudioEndpointInterface from '../../driver/PCMAudioEndpointInterface';
declare class WebAudioDriver {
    private _fragmentSize?;
    constructor(_fragmentSize?: number);
    init(): void;
    bind(pcmAudio: boolean, channels: WebAudioDriver.Channels): void;
    unbind(): void;
    setMasterVolume(volume: number): void;
    getMasterVolume(): number;
    pause(): Promise<void>;
    resume(): Promise<void>;
    private _driver;
    private _pcmAudio;
    private _volume;
    private _channels;
}
declare namespace WebAudioDriver {
    type Channels = Array<WaveformAudioOutputInterface> | Array<PCMAudioEndpointInterface>;
}
export { WebAudioDriver as default };
