import EmulationServiceInterface from './EmulationServiceInterface';
import EmulationContextInterface from './EmulationContextInterface';
declare class DriverManager {
    bind(emulationService: EmulationServiceInterface): this;
    unbind(): this;
    addDriver(driver: DriverManager.Driver, binder: DriverManager.Binder): this;
    removeDriver(driver: DriverManager.Driver): this;
    private static _onEmuStateChange;
    private _shouldBindDrivers;
    private _bindDrivers;
    private _unbindDrivers;
    private _emulationService;
    private _drivers;
    private _driversBound;
}
declare namespace DriverManager {
    interface Driver {
        unbind(): void;
    }
    interface Binder {
        (context: EmulationContextInterface, driver: Driver): void;
    }
    class DriverContext {
        driver: Driver;
        binder: Binder;
        constructor(driver: Driver, binder: Binder);
    }
}
export { DriverManager as default };
