import VideoEndpointInterface from '../../driver/VideoEndpointInterface';
import ControlPanelInterface from '../../../machine/stella/ControlPanelInterface';
import JoystickInterface from '../../../machine/io/DigitalJoystickInterface';
import PaddleInterface from '../../../machine/io/PaddleInterface';
import WaveformAudioOutputInterface from '../../../machine/io/WaveformAudioOutputInterface';
import PCMAudioEndpointInterface from '../../driver/PCMAudioEndpointInterface';
import Config from '../../../machine/stella/Config';
import AsyncIOInterface from '../../../machine/io/AsyncIOInterface';
interface EmulationContextInterface {
    getConfig(): Config;
    getVideo(): VideoEndpointInterface;
    getJoystick(i: number): JoystickInterface;
    getControlPanel(): ControlPanelInterface;
    getPaddle(i: number): PaddleInterface;
    getWaveformChannels(): Array<WaveformAudioOutputInterface>;
    getPCMChannel(): PCMAudioEndpointInterface;
    getAsyncIO(): AsyncIOInterface | undefined;
}
export default EmulationContextInterface;
