import EmulationContextInterface from '../EmulationContextInterface';
import ControlPanelInterface from '../../../../machine/stella/ControlPanelInterface';
import JoystickInterface from '../../../../machine/io/DigitalJoystickInterface';
import PaddleInterface from '../../../../machine/io/PaddleInterface';
import Board from '../../../../machine/stella/Board';
import Config from '../../../../machine/stella/Config';
import VideoEndpointInterface from '../../../driver/VideoEndpointInterface';
import VideoOutputInterface from '../../../../machine/io/VideoOutputInterface';
import WaveformAudioOutputInterface from '../../../../machine/io/WaveformAudioOutputInterface';
import PCMAudioEndpointInterface from '../../../driver/PCMAudioEndpointInterface';
import AsyncIOInterface from '../../../../machine/io/AsyncIOInterface';
export default class EmulationContext implements EmulationContextInterface {
    private _board;
    private _asyncIO?;
    constructor(_board: Board, _asyncIO?: AsyncIOInterface);
    getConfig(): Config;
    getVideo(): VideoEndpointInterface;
    getJoystick(i: number): JoystickInterface;
    getControlPanel(): ControlPanelInterface;
    getPaddle(i: number): PaddleInterface;
    getWaveformChannels(): Array<WaveformAudioOutputInterface>;
    getPCMChannel(): PCMAudioEndpointInterface;
    getRawVideo(): VideoOutputInterface;
    getAsyncIO(): AsyncIOInterface;
    private _videoEndpoint;
    private _audioEndpoint;
}
