"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const messages_1 = require("./messages");
const microevent_ts_1 = require("microevent.ts");
class AsyncIOProxy {
    constructor(_rpc) {
        this._rpc = _rpc;
        this.message = new microevent_ts_1.Event();
    }
    init() {
        this._rpc.registerSignalHandler(messages_1.SIGNAL_TYPE.messageFromAsyncIO, data => this.message.dispatch(data));
    }
    send(message) {
        this._rpc.signal(messages_1.SIGNAL_TYPE.messageToAsyncIO, Array.from(message));
    }
}
exports.default = AsyncIOProxy;
//# sourceMappingURL=AsyncIOProxy.js.map