import VideoEndpointInterface from '../../../driver/VideoEndpointInterface';
import JoystickInterface from '../../../../machine/io/DigitalJoystickInterface';
import ControlPanelInterface from '../../../../machine/stella/ControlPanelInterface';
import PaddleInterface from '../../../../machine/io/PaddleInterface';
import WaveformAudioOutputInterface from '../../../../machine/io/WaveformAudioOutputInterface';
import PCMAudioEndpointInterface from '../../../driver/PCMAudioEndpointInterface';
import Config from '../../../../machine/stella/Config';
import EmulationContextInterface from '../EmulationContextInterface';
import VideoProxy from './VideoProxy';
import ControlProxy from './ControlProxy';
import WaveformAudioProxy from './WaveformAudioProxy';
import PCMAudioProxy from './PCMAudioProxy';
import AsyncIOProxy from './AsyncIOProxy';
declare class EmulationContext implements EmulationContextInterface {
    private _videoProxy;
    private _controlProxy;
    private _waveformChannels;
    private _pcmChannel;
    private _asyncIOProxy;
    constructor(_videoProxy: VideoProxy, _controlProxy: ControlProxy, _waveformChannels: Array<WaveformAudioProxy>, _pcmChannel: PCMAudioProxy, _asyncIOProxy: AsyncIOProxy);
    setConfig(config: Config): void;
    getConfig(): Config;
    getVideo(): VideoEndpointInterface;
    getJoystick(i: number): JoystickInterface;
    getControlPanel(): ControlPanelInterface;
    getPaddle(i: number): PaddleInterface;
    getWaveformChannels(): Array<WaveformAudioOutputInterface>;
    getPCMChannel(): PCMAudioEndpointInterface;
    getVideoProxy(): VideoProxy;
    getAsyncIO(): AsyncIOProxy;
    private _config;
}
export { EmulationContext as default };
