"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = void 0;
class EmulationContext {
    constructor(_videoProxy, _controlProxy, _waveformChannels, _pcmChannel, _asyncIOProxy) {
        this._videoProxy = _videoProxy;
        this._controlProxy = _controlProxy;
        this._waveformChannels = _waveformChannels;
        this._pcmChannel = _pcmChannel;
        this._asyncIOProxy = _asyncIOProxy;
        this._config = null;
        if (this._waveformChannels.length !== 2) {
            throw new Error(`invalid channel count ${this._waveformChannels.length}`);
        }
    }
    setConfig(config) {
        this._config = config;
    }
    getConfig() {
        return this._config;
    }
    getVideo() {
        return this._videoProxy;
    }
    getJoystick(i) {
        return this._controlProxy.getJoystick(i);
    }
    getControlPanel() {
        return this._controlProxy.getControlPanel();
    }
    getPaddle(i) {
        return this._controlProxy.getPaddle(i);
    }
    getWaveformChannels() {
        return this._waveformChannels;
    }
    getPCMChannel() {
        return this._pcmChannel;
    }
    getVideoProxy() {
        return this._videoProxy;
    }
    getAsyncIO() {
        return this._asyncIOProxy;
    }
}
exports.default = EmulationContext;
//# sourceMappingURL=EmulationContext.js.map