import { RpcProviderInterface } from 'worker-rpc';
import { Event } from 'microevent.ts';
import PoolMemberInterface from '../../../../tools/pool/PoolMemberInterface';
import PCMAudioEndpointInterface from '../../../driver/PCMAudioEndpointInterface';
declare class PCMAudioProxy implements PCMAudioEndpointInterface {
    private _index;
    private _rpc;
    constructor(_index: number, _rpc: RpcProviderInterface);
    init(): this;
    start(): Promise<void>;
    stop(): void;
    isPaused(): boolean;
    getSampleRate(): number;
    getFrameSize(): number;
    private static _onReleaseFragment;
    private _onNewFrame;
    private _onTogglePause;
    newFrame: Event<PoolMemberInterface<Float32Array>>;
    togglePause: Event<boolean>;
    private _sampleRate;
    private _frameSize;
    private _paused;
    private _framePool;
    private _frameMap;
    private _enabled;
    private _signalReturnFrame;
}
export { PCMAudioProxy as default };
