import { Event } from 'microevent.ts';
import VideoEndpointInterface from '../../../driver/VideoEndpointInterface';
import { RpcProviderInterface } from 'worker-rpc';
import PoolMemberInterface from '../../../../tools/pool/PoolMemberInterface';
declare class VideoProxy implements VideoEndpointInterface {
    private _rpc;
    constructor(_rpc: RpcProviderInterface);
    init(): void;
    start(): Promise<void>;
    stop(): void;
    getWidth(): number;
    getHeight(): number;
    private static _onDisposeFrame;
    private _onNewFrame;
    newFrame: Event<PoolMemberInterface<ImageData>>;
    private _framePool;
    private _frameMap;
    private _active;
    private _width;
    private _height;
}
export { VideoProxy as default };
