import { Event } from 'microevent.ts';
import { RpcProviderInterface } from 'worker-rpc';
import WaveformAudioOutputInterface from '../../../../machine/io/WaveformAudioOutputInterface';
import StellaConfig from '../../../../machine/stella/Config';
import AudioOutputBuffer from '../../../../tools/AudioOutputBuffer';
declare class WaveformAudioProxy implements WaveformAudioOutputInterface {
    private _index;
    private _rpc;
    constructor(_index: number, _rpc: RpcProviderInterface);
    init(): this;
    start(config: StellaConfig): Promise<void>;
    setVolume(value: number): this;
    getVolume(): number;
    getBuffer(key: number): AudioOutputBuffer;
    private _onVolumeChangeSignal;
    private _onBufferChangeSignal;
    private _onStopSignal;
    bufferChanged: Event<number>;
    volumeChanged: Event<number>;
    stop: Event<void>;
    private _toneGenerator;
    private _volume;
}
export { WaveformAudioProxy as default };
