import EventServiceInterface from '../EmulationServiceInterface';
import CartridgeInfo from '../../../../machine/stella/cartridge/CartridgeInfo';
export declare const RPC_TYPE: {
    emulationPause: string;
    emulationReset: string;
    emulationResume: string;
    emulationSetRateLimit: string;
    emulationStart: string;
    emulationStop: string;
    emulationFetchLastError: string;
    getVideoParameters: string;
    getWaveformAudioParameters: (index: number) => string;
    getPCMAudioParameters: (index: number) => string;
    setup: string;
};
export declare const SIGNAL_TYPE: {
    emulationError: string;
    emulationFrequencyUpdate: string;
    videoNewFrame: string;
    videoReturnSurface: string;
    controlStateUpdate: string;
    waveformAudioVolumeChange: string;
    waveformAudioBufferChange: string;
    pcmAudioNewFrame: (index: number) => string;
    pcmAudioTogglePause: (index: number) => string;
    pcmAudioReturnFrame: (index: number) => string;
    audioStop: string;
    messageFromAsyncIO: string;
    messageToAsyncIO: string;
};
export interface SetupMessage {
}
export interface EmulationStartMessage {
    buffer: {
        [i: number]: number;
        length: number;
    };
    config: EventServiceInterface.Config;
    cartridgeType?: CartridgeInfo.CartridgeType;
}
export interface VideoParametersResponse {
    width: number;
    height: number;
}
export interface WaveformAudioParametersResponse {
    volume: number;
}
export interface VideoNewFrameMessage {
    id: number;
    width: number;
    height: number;
    buffer: ArrayBuffer;
}
export interface VideoReturnSurfaceMessage {
    id: number;
    buffer: ArrayBuffer;
}
export interface WaveformAudioVolumeChangeMessage {
    index: number;
    value: number;
}
export interface WaveformAudioBufferChangeMessage {
    index: number;
    key: number;
}
export interface PCMAudioParametersResponse {
    sampleRate: number;
    frameSize: number;
    paused: boolean;
}
export interface PCMAudioNewFrameMessage {
    buffer: ArrayBuffer;
    id: number;
}
export interface PCMAudioTogglePauseMessage {
    paused: boolean;
}
export interface PCMAudioReturnFrameMessage {
    id: number;
    buffer: ArrayBuffer;
}
export declare type MessageFromAsyncIOMessage = ArrayLike<number>;
export declare type MessageToAsyncIOMessage = Array<number>;
