"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SIGNAL_TYPE = exports.RPC_TYPE = void 0;
exports.RPC_TYPE = {
    emulationPause: 'emulation/pause',
    emulationReset: 'emulation/reset',
    emulationResume: 'emulation/resume',
    emulationSetRateLimit: 'emulation/setRateLimit',
    emulationStart: 'emulation/start',
    emulationStop: 'emulation/stop',
    emulationFetchLastError: 'emulation/fetchLastError',
    getVideoParameters: 'video/getParameters',
    getWaveformAudioParameters: (index) => `audio/waveform/getParameters/${index}`,
    getPCMAudioParameters: (index) => `audio/pcm/getParameters/${index}`,
    setup: '/setup'
};
Object.freeze(exports.RPC_TYPE);
exports.SIGNAL_TYPE = {
    emulationError: 'emulation/error',
    emulationFrequencyUpdate: 'emulation/frequencyUpdate',
    videoNewFrame: 'video/newFrame',
    videoReturnSurface: 'video/returnSurface',
    controlStateUpdate: 'control/stateUpdate',
    waveformAudioVolumeChange: 'audio/waveform/volumeChange',
    waveformAudioBufferChange: 'audio/waveform/bufferChange',
    pcmAudioNewFrame: (index) => `audio/pcm/newFrame/${index}`,
    pcmAudioTogglePause: (index) => `audio/pcm/togglePause/${index}`,
    pcmAudioReturnFrame: (index) => `audio/pcm/returnFrame/${index}`,
    audioStop: 'audio/stop',
    messageFromAsyncIO: 'asyncIO/messageFrom',
    messageToAsyncIO: 'asyncIO/messageTo'
};
Object.freeze(exports.SIGNAL_TYPE);
//# sourceMappingURL=messages.js.map